import { UserConfig } from '@unocss/core';
type CSSImporter = (id: string) => Promise<string | null>;
export interface BuildContext {
    isProduction: boolean;
    cssClasses: Set<string>;
    safelist: string[];
}
export declare function transformCSS(config: UserConfig, css: string): Promise<string>;
export declare function purgeCss(html: string, css: string): Promise<string>;
export declare function createBuildContext(isProduction: boolean, safelist: string[]): BuildContext;
export declare function prepareStyles(context: BuildContext, contents: string): Promise<string>;
export declare function createStylesheet(cssConfig: UserConfig, classes: Set<string>, minify: boolean, cssImporter: CSSImporter, leadingCss?: string): Promise<string>;
export declare function finalizePage(contents: string, stylesheet: string, safelist?: string[]): Promise<string>;
export {};
